CHCP 1251
@ECHO OFF
REM *** 
REM Created Data : 23:17 06.01.2023
REM Author : Dmitry, Ekaterinburg, Russia
REM QTH locator : MO06HU
REM WebSite : https://techstop-ekb.ru/
REM E-mail : d.e.bobin@yandex.ru
REM ***
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
REM
REM *** Reading sat-gen-tle-v5.cfg settings file and setting variables ... 
REM ***    sat-gen-tle-v5.cfg    ... 
FOR /F "eol=; tokens=1,2* delims==" %%A IN (sat-gen-tle-v5.cfg) DO (
	IF %%A==DosCode (SET DosCode=%%B)
	IF %%A==HelpLng (SET HelpLng=%%B)
	IF %%A==HelpMsg (SET HelpMsg=%%B)
	IF %%A==AISDBRUPD (SET AISDBRUPD=%%B)
	IF %%A==AICITCOUN (SET AICITCOUN=%%B)
	IF %%A==AIWEBSITE (SET AIWEBSITE=%%B)
	IF %%A==AISDBDUPD (SET AISDBDUPD=%%B)
)
REM ***
CHCP !DosCode!
CLS
TYPE help\!HelpLng!\sat-gen-tle-v5.ver
PAUSE
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\10-10.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\10-20.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\10-25.txt
SET /P SatNum=
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\10-30.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\10-40.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\10-45.txt
SET /P SatType=
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\10-50.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\10-55.txt
SET /P SatMode=
CLS
TYPE help\!HelpLng!\10-65.txt
SET /P SatFreqULbig=
IF NOT !SatFreqULbig!==0 (
	FOR /F "tokens=1,2* delims=." %%A IN ("!SatFreqULbig!") DO SET SatFreqULsml=%%A
)
IF !SatFreqULbig!==0 (SET SatFreqULsml=!SatFreqULbig!)
CLS
TYPE help\!HelpLng!\10-75.txt
SET /P SatFreqDLbig=
IF NOT !SatFreqDLbig!==0 (
	FOR /F "tokens=1,2* delims=." %%A IN ("!SatFreqDLbig!") DO SET SatFreqDLsml=%%A
)
IF !SatFreqDLbig!==0 (SET SatFreqDLsml=!SatFreqDLbig!)
REM ***
REM *** add Sat File Num - Type - Mode - SatFreqULsml - SatFreqDLsml
SET SdbFileName=satdb\!SatNum!-!SatType!-!SatMode!-!SatFreqULsml!-!SatFreqDLsml!.txt
IF EXIST !SdbFileName! (notepad !SdbFileName!)
IF NOT EXIST !SdbFileName! (
	COPY _nul.dat !SdbFileName!
	REM *** Insert Sat FREQ into file ... 
	ECHO !SatFreqULbig!>>!SdbFileName!
	ECHO !SatFreqDLbig!>>!SdbFileName!
)
REM *** add Sat Name ... 
IF EXIST satdb\!SatNum!-SatName.txt (notepad satdb\!SatNum!-SatName.txt)
IF NOT EXIST satdb\!SatNum!-SatName.txt (
	COPY _nul.dat satdb\!SatNum!-SatName.txt
	ECHO NAME: >>satdb\!SatNum!-SatName.txt
	notepad satdb\!SatNum!-SatName.txt
)
REM *** add Sat CallSign ... 
REM ... default status NA ... 
IF EXIST satdb\!SatNum!-CallSign.txt (notepad satdb\!SatNum!-CallSign.txt)
IF NOT EXIST satdb\!SatNum!-CallSign.txt (
	COPY _nul.dat satdb\!SatNum!-CallSign.txt
	ECHO CALLSIGN: NA>>satdb\!SatNum!-CallSign.txt
	notepad satdb\!SatNum!-CallSign.txt
)
REM *** add Sat Note ...
IF EXIST satdb\!SatNum!-SatNote.txt (notepad satdb\!SatNum!-SatNote.txt)
IF NOT EXIST satdb\!SatNum!-SatNote.txt (
	COPY _nul.dat satdb\!SatNum!-SatNote.txt
	ECHO NOTES: >>satdb\!SatNum!-SatNote.txt
	notepad satdb\!SatNum!-SatNote.txt
)
REM *** add Sat DB update info ... 
IF NOT EXIST satdb\!SatNum!-SatUpdate.txt (
	COPY _nul.dat satdb\!SatNum!-SatUpdate.txt
	ECHO UPDATED: by !AISDBRUPD!, !AICITCOUN!, !AIWEBSITE!, !AISDBDUPD! ... >>satdb\!SatNum!-SatUpdate.txt)
ENDLOCAL
EXIT
