CHCP 1251
@ECHO OFF
REM *** 
REM Created Data : 3:38 07.01.2023
REM Author : Dmitry, Ekaterinburg, Russia
REM QTH locator : MO06HU
REM WebSite : https://techstop-ekb.ru/
REM E-mail : d.e.bobin@yandex.ru
REM ***
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
REM
REM *** Reading sat-gen-tle-v5.cfg settings file and setting variables ... 
REM ***    sat-gen-tle-v5.cfg    ... 
FOR /F "eol=; tokens=1,2* delims==" %%A IN (sat-gen-tle-v5.cfg) DO (
	IF %%A==DosCode (SET DosCode=%%B)
	IF %%A==HelpLng (SET HelpLng=%%B)
	IF %%A==HelpMsg (SET HelpMsg=%%B)
	IF %%A==SatNum (SET SatNum=%%B)
	IF %%A==SatType (SET SatType=%%B)
	IF %%A==SatMode (SET SatMode=%%B)
	IF %%A==DLFreqMin (SET DLFreqMin=%%B)
	IF %%A==DLFreqMax (SET DLFreqMax=%%B)
)
REM ***
CHCP !DosCode!
CLS
TYPE help\!HelpLng!\sat-gen-tle-v5.ver
PAUSE
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-10.txt
		PAUSE
		CLS
	)
REM *** Setting the counter of found satellites ...     ... 
SET SCNT=0
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-20.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-30.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-40.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\30-45.txt
PAUSE
notepad sat-gen-tle-v5.cfg
REM ***
CLS
TYPE help\!HelpLng!\30-55.txt
PAUSE
	REM *** sat-list.txt ... Cleaning up a file ...   ... 
COPY _nul.dat sat-list.txt
	REM *** Search for satellites in the database ...      ...
FOR %%I IN (satdb\!SatNum!-!SatType!-!SatMode!*.txt) DO (
	SET STMA=%%I
	SET STMB=!STMA:~6,-4!
	FOR /F "tokens=1,2,3,4,5 delims=-" %%A IN ("!STMB!") DO (
		IF %%E GEQ !DLFreqMin! (
			IF %%E LEQ !DLFreqMax! (
				ECHO %%A>>sat-list.txt
				SET /A SCNT+=1
			)
		)
	)
)
REM *** Clearing the screen before displaying search results ... 
REM ***       ... 
CLS
IF NOT !SCNT!==0 (
	TYPE help\!HelpLng!\30-65.txt
	PAUSE
	notepad sat-list.txt
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-70.txt
		PAUSE
		CLS
	)
)
IF !SCNT!==0 (
	TYPE help\!HelpLng!\30-75.txt
	PAUSE
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\30-80.txt
		PAUSE
		CLS
	)
)
ENDLOCAL
EXIT
