CHCP 1251
@ECHO OFF
REM *** 
REM Created Data : 4:20 06.01.2024
REM Author : Dmitry, Ekaterinburg, Russia
REM QTH locator : MO06HU
REM WebSite : https://techstop-ekb.ru/
REM E-mail : d.e.bobin@yandex.ru
REM ***
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
REM
REM ###########################################################
REM
REM *** Reading sat-gen-tle-v5.cfg settings file and setting variables ... 
REM ***    sat-gen-tle-v5.cfg    ... 
FOR /F "eol=; tokens=1,2* delims==" %%A IN (sat-gen-tle-v5.cfg) DO (
	REM
	IF %%A==DosCode (SET DosCode=%%B)
	IF %%A==HelpLng (SET HelpLng=%%B)
	IF %%A==HelpMsg (SET HelpMsg=%%B)
	REM
	REM *** RTL SDR Radio Receive Bandwidth Variables ... 
	REM ***      RTL SDR Radio ... 
	REM
	IF %%A==BWAM (SET BWAM=%%B)
	IF %%A==BWCW (SET BWCW=%%B)
	IF %%A==BWDSB (SET BWDSB=%%B)
	IF %%A==BWLSB (SET BWLSB=%%B)
	IF %%A==BWNFM (SET BWNFM=%%B)
	IF %%A==BWRAW (SET BWRAW=%%B)
	IF %%A==BWUSB (SET BWUSB=%%B)
	IF %%A==BWWFM (SET BWWFM=%%B)
	REM
	REM *** Setting File Paths ... 
	REM ***    ... 
	REM
	REM *** TLE Space Track 3LE file path variable ... 
	REM ***     TLE Space Track 3LE ... 
	IF %%A==3LEDB (SET 3LEDB=%%B)
	REM
	REM *** Variable path to Notes files for Orbitron ... 
	REM ***     Notes  Orbitron ... 
	IF %%A==NOTESFLS (SET NOTESFLS=%%B)
	REM
	REM *** DDESchedule.xml path variable for SDRSharp ... 
	REM ***     DDESchedule.xml  SDRSharp ... 
	IF %%A==DDESXML (SET DDESXML=%%B)
	REM
	REM *** Radio.his file path variable for Orbitron ... 
	REM ***     Radio.his  Orbitron ... 
	IF %%A==RADIOHIS (SET RADIOHIS=%%B)
	REM
	REM *** Variable path to my-tle.txt file for Orbitron ... 
	REM ***     my-tle.txt  Orbitron ... 
	IF %%A==MYTLE (SET MYTLE=%%B)
	REM
	REM *** Loading Satellite Selection Filter Criteria Variables ... 
	REM ***       ... 
	REM
	IF %%A==SatNum (SET SatNum=%%B)
	IF %%A==SatType (SET SatType=%%B)
	IF %%A==SatMode (SET SatMode=%%B)
	IF %%A==DLFreqMin (SET DLFreqMin=%%B)
	IF %%A==DLFreqMax (SET DLFreqMax=%%B)
)
REM ###########################################################
REM ***
CHCP !DosCode!
CLS
TYPE help\!HelpLng!\sat-gen-tle-v5.ver
PAUSE
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-10.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-20.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\40-25.txt
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-30.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\40-35.txt
PAUSE
notepad sat-list.txt
REM ###########################################################
REM
REM *** Creating a temporary list, sorting, checking for duplicates ... 
REM ***   , ,    ...
CLS
COPY _nul.dat sat-list.tmp
SORT sat-list.txt /O sat-list.tmp
COPY _nul.dat sat-list.txt
FOR /F "tokens=*" %%I IN (sat-list.tmp) DO (
	CALL str-check-tool.cmd %%I sat-list.txt
	IF !ERRORLEVEL!==1 (
		ECHO %%I>>sat-list.txt
	)
)
REM ###########################################################
REM
REM *** Settings and configuration of generated DDE / TLE files ... 
REM ***      DDE / TLE ... 
CLS
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-40.txt
		PAUSE
		CLS
	)
TYPE help\!HelpLng!\40-45.txt
SET /P UserSdrMode=
CLS
	REM ... Reserved ...  ... 
	REM ECHO    ... 
	REM ECHO 1 -  ...   UserSdrMode -    ... 
	REM ECHO 2 -  ...  ThisSdrMode      ...
	REM ECHO 3 -  ...  ...       ...
	REM ECHO     Enter ... 
	REM SET /P GenMode=
	REM
	REM ***       SDR Radio ... 
	REM GenMode 1 ByUserCfg   UserSdrMode 
	REM  AM CW DSB LSB NFM RAW USB WFM
	REM       
	REM BWAM BWCW BWDSB BWLSB BWNFM BWRAW BWUSB BWWFM
	REM
REM *** Default = user preference settings ... 
REM ***   =    ... 
SET ThisSDRMode=!UserSdrMode!
	REM
	REM GenMode 2 BySatCfg  ,    ,  ,
	REM    ...     ... 
	REM AIS ADSB APRS BCN DGPTR IOT M2M RPTR 
	REM SCIDAT SSDV SSTV TLM TRNPD WIMG EIMG 
	REM     -      ...
	REM
	REM ***    -  GenMode = 2 BySatCfg ... 
	REM ***     ... 
	REM ***   %%B = ThisSatType ... %% = ThisSatMode ... 
	REM ***   ... 
	REM IF GenMode==2 ...  ...       
	REM       ... 
	REM 	IF %%B==BCN
	REM		 IF %%C==CW (SET ThisSDRMode=!PreSetCW!)
	REM        ... 
	REM    /    ...
	REM       -  ... 
	REM ,    -  
	REM   ,      ... 
	REM
REM *** Binding to the selected mode - SDR Radio channel bandwidth width from the default settings ...
REM ***     -   SDR Radio     ... 
REM
IF !ThisSDRMode!==AM (SET ThisSDRBW=!BWAM!)
IF !ThisSDRMode!==CW (SET ThisSDRBW=!BWCW!)
IF !ThisSDRMode!==DSB (SET ThisSDRBW=!BWDSB!)
IF !ThisSDRMode!==LSB (SET ThisSDRBW=!BWLSB!)
IF !ThisSDRMode!==NFM (SET ThisSDRBW=!BWNFM!)
IF !ThisSDRMode!==RAW (SET ThisSDRBW=!BWRAW!)
IF !ThisSDRMode!==USB (SET ThisSDRBW=!BWUSB!)
IF !ThisSDRMode!==WFM (SET ThisSDRBW=!BWWFM!)
REM
REM ###########################################################
REM
REM *** Generating DDE / TLE files ... Preparing ... Cleaning the Notes folder from previous files ... 
REM *** Check if the Notes folder - exists... Else - create ... 
REM
REM ***   DDE / TLE ...  ...   Notes    ... 
REM *** ,   Notes -  ...  -  ... 
DEL !NOTESFLS!\*.txt
IF !ERRORLEVEL!==1 (MKDIR !NOTESFLS!)
REM
REM *** Insert original marker blank Notes template 00000.txt
REM ***     Notes template 00000.txt ... 
IF NOT EXIST !NOTESFLS!\00000.txt (COPY ddexml\00000.txt !NOTESFLS!\00000.txt)
REM
REM *** Start building DDESchedule.xml file ... 
REM ***    DDESchedule.xml ... 
COPY _nul.dat !DDESXML!
TYPE ddexml\DDESchedule1.dat>>!DDESXML!
REM
REM *** Start building Radio.his file ... 
REM ***    Radio.his ... 
COPY ddexml\Radio.dat !RADIOHIS!
REM
REM *** Start building my-tle.txt file ... 
REM ***    my-tle.txt ... 
COPY _nul.dat !MYTLE!
REM
REM ###########################################################
REM
REM *** We start the main loop for polling the list of satellites ... 
REM ***       ... 
FOR /F "tokens=*" %%S IN (sat-list.txt) DO (
	REM *** Checking the satellite for compliance with the conditions of use ... 
	REM ***       ... 
	REM *** Search for satellites in the database ... 
	REM ***      ...
REM *** search cycle start ... 
	FOR %%I IN (satdb\%%S-!SatType!-!SatMode!*.txt) DO (
		SET STMA=%%I
		SET STMB=!STMA:~6,-4!
		FOR /F "tokens=1,2,3,4,5 delims=-" %%A IN ("!STMB!") DO (
REM *** For This Sat ... %%A Num, %%B Type, %%C Mode, %%D Freq UL, %%E Freq DL ... 
			IF %%E GEQ !DLFreqMin! (
				IF %%E LEQ !DLFreqMax! (
REM *** inner overcycle start ... 
REM *** It looks like the searched sutnik has been found ... We are trying to write files ... 
REM *** ,   -  ...    ... 
	REM *** Binding to the frequency of the selected satellite ... 
	REM ***      ... 
	REM *** Setting the Row Read Order Count ... 
	REM ***      ... 
	SET FileStrNum=1
	REM *** Resetting current frequency variables ... 
	REM ***     ... 
	SET ThisFreqUL=0
	SET ThisFreqDL=0
	FOR /F "tokens=*" %%F IN (%%I) DO (
		IF !FileStrNum!==1 (
			IF NOT %%F==0 (SET ThisFreqUL=%%F)
			SET /A FileStrNum+=1
		)
		IF !FileStrNum!==2 (
			IF NOT %%F==0 (SET ThisFreqDL=%%F)
		)
	)
REM
REM *** We write Notes txt
REM ***  Notes txt ... 
IF NOT EXIST !NOTESFLS!\%%S.txt (
	COPY satdb\%%S-SatName.txt !NOTESFLS!\%%S.txt
		IF NOT !ERRORLEVEL!==0 (ECHO %%S nnn1>>report.txt)
	IF NOT !ThisFreqUL!==0 (ECHO UPLINK: !ThisFreqUL!>>!NOTESFLS!\%%S.txt) ELSE ECHO UPLINK: >>!NOTESFLS!\%%S.txt
	IF NOT !ThisFreqDL!==0 (ECHO DNLINK: !ThisFreqDL!>>!NOTESFLS!\%%S.txt) ELSE ECHO DNLINK: >>!NOTESFLS!\%%S.txt
	TYPE satdb\%%S-CallSign.txt>>!NOTESFLS!\%%S.txt
		IF NOT !ERRORLEVEL!==0 (ECHO %%S nnn2>>report.txt)
	TYPE satdb\%%S-SatNote.txt>>!NOTESFLS!\%%S.txt
		IF NOT !ERRORLEVEL!==0 (ECHO %%S nnn3>>report.txt)
	TYPE satdb\%%S-SatUpdate.txt>>!NOTESFLS!\%%S.txt
		IF NOT !ERRORLEVEL!==0 (ECHO %%S nnn4>>report.txt)
REM
REM *** Writing record in DDESchedule.xml ... 
REM ***    DDESchedule.xml ... 
ECHO   ^<SchedulerEntry^>>>!DDESXML!
ECHO     ^<SatName^>%%S^</SatName^>>>!DDESXML!
ECHO     ^<OnCommands^>>>!DDESXML!
ECHO       ^<string^>radio_modulation_type^&lt;!ThisSDRMode!^&gt;^</string^>>>!DDESXML!
ECHO       ^<string^>radio_bandwidth_Hz^&lt;!ThisSDRBW!^&gt;^</string^>>>!DDESXML!
ECHO       ^<string^>radio_tracking_frequency_On^</string^>>>!DDESXML!
ECHO       ^<string /^>>>!DDESXML!
ECHO     ^</OnCommands^>>>!DDESXML!
ECHO     ^<OffComands /^>>>!DDESXML!
ECHO   ^</SchedulerEntry^>>>!DDESXML!
REM
REM *** Writing record in Radio.his ... 
REM ***    Radio.his ... 
REM
REM *** Special module for bringing the satellite frequency to a single value 
REM *** in the file Radio.his Doppler corrector Orbitron, with six zeros ... 
REM ***         
REM ***    Radio.his   Orbitron,    ... 
	IF NOT !ThisFreqUL!==0 (
		REM *** Temporarily pad the frequency with six zeros ... 
		REM ***      ... 
		SET ThisFreqULA=!ThisFreqUL!000000
		REM *** Separate integer and decimal frequency value ... 
		REM ***       ...
		FOR /F "tokens=1,2* delims=." %%X IN ("!ThisFreqULA!") DO (
			SET ThisFreqULX=%%X
			SET ThisFreqULZ=%%Y
		REM *** Trim final decimal value of frequency to 6 zeros ... 
		REM ***       6 ... 
			SET ThisFreqULY=!ThisFreqULZ:~0,6!
		)
		SET ThisFreqUL=!ThisFreqULX!.!ThisFreqULY!
		ECHO %%S_up=!ThisFreqUL!>>!RADIOHIS!
	)
	IF NOT !ThisFreqDL!==0 (
		REM *** Temporarily pad the frequency with six zeros ... 
		REM ***      ... 
		SET ThisFreqDLA=!ThisFreqDL!000000
		REM *** Separate integer and decimal frequency value ... 
		REM ***       ...
		FOR /F "tokens=1,2* delims=." %%X IN ("!ThisFreqDLA!") DO (
			SET ThisFreqDLX=%%X
			SET ThisFreqDLZ=%%Y
		REM *** Trim final decimal value of frequency to 6 zeros ... 
		REM ***       6 ... 
			SET ThisFreqDLY=!ThisFreqDLZ:~0,6!
		)
		SET ThisFreqDL=!ThisFreqDLX!.!ThisFreqDLY!
		ECHO %%S_dn=!ThisFreqDL!>>!RADIOHIS!
	)
REM
REM *** Writing record in my-tle.txt ... 
REM ***    my-tle.txt ... 
FINDSTR /B /C:"1 %%S" !3LEDB!>>!MYTLE!
FINDSTR /B /C:"2 %%S" !3LEDB!>>!MYTLE!
)
REM *** inner overcycle end ... 
				)
			)
		)
	)
REM *** search cycle end ... 
)
REM *** We complete the recording DDESchedule.xml ... 
REM ***   DDESchedule.xml ... 
TYPE ddexml\DDESchedule2.dat>>!DDESXML!
REM
REM *** Module for counting generated files
REM ***     ... 
	SET NOTESFLSCNT=0
	FOR %%N IN (!NOTESFLS!\*.txt) DO (
		ECHO %%N
		SET /A NOTESFLSCNT+=1
	)
	IF !NOTESFLSCNT!==1 (
		CLS
		TYPE help\!HelpLng!\40-47.txt
		PAUSE
		CLS
		notepad sat-gen-tle-v5.cfg
	)
REM *** end of counting module ...    ... 
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-50.txt
		PAUSE
		CLS
	)
	IF !HelpMsg!==1 (
		CLS
		TYPE help\!HelpLng!\40-60.txt
		PAUSE
		CLS
	)
ENDLOCAL
EXIT
